segment code
..start:
        ; Initialization
        mov     ax, data
        mov     ds, ax
        mov     ax, stack
        mov     ss, ax
        mov     sp, stacktop
                ; Display title
                mov     dx, stitle
        mov     ah, 9
        int     21h
                ; Ask for operation
        mov     dx, sop
        mov     ah, 9
        int     21h
        ; Get operation from keyboard buffer
        mov     dx, buffer
        mov     ah, 0ah
        int     21h
        mov     al, [buffer + 2]                 ; first operand
        mov     ah, 0
        mov     bl, [buffer + 4]                 ; second operand
        mov     cl, [buffer + 3]                 ; operator
        ; Branch depending on operator
        cmp     cl, '+'
        je      addition
        cmp     cl, '-'
        je      subtraction
        cmp     cl, '*'
        je      multiplication
        ; Display invalid operator message
        mov     dx, serr
        mov     ah, 9
        int     0x21
        jmp     exit
        ; Do addition
addition:
        add     al, bl
        aaa
        jmp     result
        ; Do subtraction
subtraction:
        cmp     al, bl
        jl      negative
        sub     al, bl
        aas
        jmp     result
negative:
        mov     dx, sneg
        mov     ah, 9
        int     21h
        jmp     exit
        ; Do multiplication
multiplication:
        and     al, 0fh
        and     bl, 0fh
        mul     bl
        aam
        ; Display result
result:
        or      ax, 3030h
        mov     [res], ah
        mov     [res + 1], al
        mov     dx, sresult
        mov     ah, 9
        int     21h
        ; Terminate the program
exit:
        mov     ax, 0x4c00
        int     21h

segment data
stitle  db      'Addition, subtraction, and multiplication', 13, 10
        db      'of two 1-digit positive integers', 13, 10, '$'
sop     db      'Operation ? ', '$'
serr    db      13, 10, 'Unknown operator!', 13, 10, '$'
sneg    db      13, 10, 'Result is negative', 13, 10, '$'
buffer  db      4
        resb    5
sresult db      13, 10, 'Result = '
res     resb    2
        db      13, 10, '$'

segment stack   stack
        resb    64
stacktop:
